//==============================================================================
// PS2SUP.h - Simple PS2 support functions 
//
// Version 0.1 - Work in Progress
//
// Major Contributers: Kurt Eckhardt 
// 		Robert V Mahoney Jr
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//==============================================================================
#ifndef _PS2SUP_H_
#define _PS2SUP_H_
#ifdef __cplusplus
extern "C" {
#endif

//-----------------------------------------------------------------------------
// Define some constants.  Will allow the caller to override these before
//				they include this header file
//-----------------------------------------------------------------------------
#ifndef PS2_DAT
#define PS2_DAT		P12
#define PS2_CMD		P13
#define PS2_SEL		P14
#define PS2_CLK		P15
#endif			// could allow individual overrides but good enough for now...

//-----------------------------------------------------------------------------
// Define some data types
//-----------------------------------------------------------------------------


// Main data packet						
typedef struct _ps2packet {
	union
	{
		byte	bData[6];
		struct
		{
			byte fNLeft : 1; 
			byte fNDown : 1;  
			byte fNRight: 1;  
			byte fNUp : 1; 
			byte fNStart : 1;
			byte fNR3 : 1; 				// is pressed if the value is 0...
			byte fNL3 : 1;				// Warning these are Negaitve ie button
			byte fNSelect :1;			// These are the 16 buttons...

			byte fNSquare : 1;
			byte fNX : 1; 
			byte fNO : 1; 
			byte fNTriangle : 1; 
			byte fNR1 : 1; 
			byte fNL1 : 1; 
			byte fNR2 : 1; 
			byte fNL2 : 1; 

			byte	bRJoyLR;					// right joystick X (LR)
			byte	bRJoyUD;					//				..Y (UD)
			byte	bLJoyLR;					// Left Joystick  X (LR)
			byte	bLJoyUD;					// 				  Y (UD)
		} s;
	};
} PS2PACKET;

//-----------------------------------------------------------------------------
// Global Data definitions
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Function definitions.
//-----------------------------------------------------------------------------
extern void PS2_Init(u8 bDat, u8 bCmd, u8 bSel, u8 bClk) ;  // pass in which pins you wish to use
extern u8 PS2_Query(unsigned char *paData, int cb);

#ifdef __cplusplus
}
#endif

#endif
