// Warning this is a merged version for Bap8 as well
// as Bap40/Arc32...
#ifndef BASICATOMPRO28
#ifndef BASICATOMPRO40
#ifndef BASICATOMPROARC32
#WARNING "regdefs.h - default to BASICATOMPRO28"
#define BASICATOMPRO28
#endif
#endif
#endif

#ifdef BASICATOMPRO28

//************************************
//Undefine any of the below interrupts
//you want to use in your program
//************************************
//
//#define USEINT_IRQ_0
//#define USEINT_IRQ_1
//#define USEINT_IRQ_2
//#define USEINT_IRQ_3
//#define USEINT_WKP
#define USEINT_TIMERAV
#define USEINT_TIMERW
//#define USEINT_TIMERV
#define USEINT_SCI3
//#define USEINT_IIC
//#define USEINT_ADCONV
//#define USEINT_TIMERZ0
//#define USEINT_TIMERZ1
//#define USEINT_TIMERB1
//#define USEINT_SCI3_2
#else
//#define USEINT_IRQ_0
//#define USEINT_IRQ_1
//#define USEINT_IRQ_2
//#define USEINT_IRQ_3
//#define USEINT_WKP
//#define USEINT_TIMERAV
//#define USEINT_TIMERW
//#define USEINT_TIMERV
#define USEINT_SCI3
//#define USEINT_IIC
//#define USEINT_ADCONV
#define USEINT_TIMERZ0
#define USEINT_TIMERZ1
#define USEINT_TIMERB1
#define USEINT_SCI3_2
#endif

#define USE_UNHANDLED_INTS		// uncomment to handle your own unknown interrupt handler

#ifndef _REGDEFS_H_
#define _REGDEFS_H_

//**********************
//CCR macros and inlines
//**********************
#define and_ccr(mask) asm ("andc.b %0,ccr"::"g"(mask));
#define or_ccr(mask) asm ("orc.b %0,ccr"::"g"(mask));
#define xor_ccr(mask) asm ("xorc.b %0,ccr"::"g"(mask));

__inline__ unsigned char get_ccr(void) __attribute__ ((always_inline));
__inline__ unsigned char get_ccr(void)
{
      unsigned char ccr_val;
      asm("stc ccr,r0l":::"r0");
      asm("mov.b r0l, %0l":"=g"(ccr_val));
      return(ccr_val);
}

//**********************
//Simple type definition
//**********************
union BYTE {
	unsigned char Byte;
	struct {
		unsigned char Bit7:1;
		unsigned char Bit6:1;
		unsigned char Bit5:1;
		unsigned char Bit4:1;
		unsigned char Bit3:1;
		unsigned char Bit2:1;
		unsigned char Bit1:1;
		unsigned char Bit0:1;
	};
};

union WORD {
	unsigned int Word;
	struct {
		unsigned char Byte1;
		unsigned char Byte0;
	};
	struct {
		unsigned char Bit15:1;
		unsigned char Bit14:1;
		unsigned char Bit13:1;
		unsigned char Bit12:1;
		unsigned char Bit11:1;
		unsigned char Bit10:1;
		unsigned char Bit9:1;
		unsigned char Bit8:1;
		unsigned char Bit7:1;
		unsigned char Bit6:1;
		unsigned char Bit5:1;
		unsigned char Bit4:1;
		unsigned char Bit3:1;
		unsigned char Bit2:1;
		unsigned char Bit1:1;
		unsigned char Bit0:1;
	};
};

union LONG {
	unsigned long Long;
	struct {
		unsigned int Word1;
		unsigned int Word0;
	};
	struct {
		unsigned char Byte3;
		unsigned char Byte2;
		unsigned char Byte1;
		unsigned char Byte0;
	};
	struct {
		unsigned char Bit31:1;
		unsigned char Bit30:1;
		unsigned char Bit29:1;
		unsigned char Bit28:1;
		unsigned char Bit27:1;
		unsigned char Bit26:1;
		unsigned char Bit25:1;
		unsigned char Bit24:1;
		unsigned char Bit23:1;
		unsigned char Bit22:1;
		unsigned char Bit21:1;
		unsigned char Bit20:1;
		unsigned char Bit19:1;
		unsigned char Bit18:1;
		unsigned char Bit17:1;
		unsigned char Bit16:1;
		unsigned char Bit15:1;
		unsigned char Bit14:1;
		unsigned char Bit13:1;
		unsigned char Bit12:1;
		unsigned char Bit11:1;
		unsigned char Bit10:1;
		unsigned char Bit9:1;
		unsigned char Bit8:1;
		unsigned char Bit7:1;
		unsigned char Bit6:1;
		unsigned char Bit5:1;
		unsigned char Bit4:1;
		unsigned char Bit3:1;
		unsigned char Bit2:1;
		unsigned char Bit1:1;
		unsigned char Bit0:1;
	};
};
#ifndef _H8_REG_DEFS_H_
//*****************************
//Hardware Register Definitions
//*****************************
#define TCR_0 (*(volatile BYTE *) 0xF700) //Timer control register 0
#define TIORA_0 (*(volatile BYTE *) 0xF701) //Timer I/O control register A 0
#define TIORC_0 (*(volatile BYTE *) 0xF702) //Timer I/O control register C 0
#define TSR_0 (*(volatile BYTE *) 0xF703) //Tiemr status register 0
#define TIER_0 (*(volatile BYTE *) 0xF704) //Timer interrupt enable register 0
#define POCR_0 (*(volatile BYTE *) 0xF705) //PWM mode output level control register 0
#define TCNT_0 (*(volatile WORD *) 0xF706) //Timer counter 0
#define GRA_0 (*(volatile WORD *) 0xF708) //General register A 0
#define GRB_0 (*(volatile WORD *) 0xF70A) //General register B 0
#define GRC_0 (*(volatile WORD *) 0xF70C) //General register C 0
#define GRD_0 (*(volatile WORD *) 0xF70E) //General register D 0
#define TCR_1 (*(volatile BYTE *) 0xF710) //Timer control register 1
#define TIORA_1 (*(volatile BYTE *) 0xF711) //Timer I/O control register A 1
#define TIORC_1 (*(volatile BYTE *) 0xF712) //Timer I/O control register C 1
#define TSR_1 (*(volatile BYTE *) 0xF713) //Tiemr status register 1
#define TIER_1 (*(volatile BYTE *) 0xF714) //Timer interrupt enable register 1
#define POCR_1 (*(volatile BYTE *) 0xF715) //PWM mode output level control register 1
#define TCNT_1 (*(volatile WORD *) 0xF716) //Timer counter 1
#define GRA_1 (*(volatile WORD *) 0xF718) //General register A 1
#define GRB_1 (*(volatile WORD *) 0xF71A) //General register B 1
#define GRC_1 (*(volatile WORD *) 0xF71C) //General register C 1
#define GRD_1 (*(volatile WORD *) 0xF71E) //General register D 1
#define TSTR (*(volatile BYTE *) 0xF720) //Timer start register
#define TMDR (*(volatile BYTE *) 0xF721) //Timer mode register
#define TPMR (*(volatile BYTE *) 0xF722) //Timer PWM mode register
#define TFCR (*(volatile BYTE *) 0xF723) //Timer Z, for common use
#define TOER (*(volatile BYTE *) 0xF724) //Timer output master enable register
#define TOCR (*(volatile BYTE *) 0xF725) //Timer output control register

#define RSECDR (*(volatile BYTE *) 0xF728) //Second data register
#define RMINDR (*(volatile BYTE *) 0xF729) //Minute data register
#define RHRDR (*(volatile BYTE *) 0xF72A) //Hour data register
#define RWKDR (*(volatile BYTE *) 0xF72B) //Day of week data register
#define RTCCR1 (*(volatile BYTE *) 0xF72C) //RTC control register 1
#define RTCCR2 (*(volatile BYTE *) 0xF72D) //RTC control register 2
#define RTCCSR (*(volatile BYTE *) 0xF72F) //Clock source select register

#define LVDCR (*(volatile BYTE *) 0xF730) //Low voltage detection control register
#define LVDSR (*(volatile BYTE *) 0xF731) // Low voltage detection status register

#define SMR_2 (*(volatile BYTE *) 0xF740) //Serial mode reigster 2
#define BRR_2 (*(volatile BYTE *) 0xF741) //Bit rate register 2
#define SCR3_2 (*(volatile BYTE *) 0xF742) //Serial control register 3 2
#define TDR_2 (*(volatile BYTE *) 0xF743) //Transmit data register 2
#define SSR_2 (*(volatile BYTE *) 0xF744) //Serial status register 2
#define RDR_2 (*(volatile BYTE *) 0xF745) //Receive data register 2

#define ICCR1 (*(volatile BYTE *) 0xF748) //I2C bus control register 1
#define ICCR2 (*(volatile BYTE *) 0xF749) //I2C bus control register 2
#define ICMR (*(volatile BYTE *) 0xF74A) //I2C bus mode register
#define ICIER (*(volatile BYTE *) 0xF74B) //I2C bus interrupt enable register
#define ICSR (*(volatile BYTE *) 0xF74C) //I2C status register
#define SAR (*(volatile BYTE *) 0xF74D) //Slave address register
#define ICDRT (*(volatile BYTE *) 0xF74E) //I2C bus transmit data register
#define ICDRR (*(volatile BYTE *) 0xF74F) //I2C bus receiver data register

#define TMB1 (*(volatile BYTE *) 0xF760) //Timer mode register B1
#define TCB1 (*(volatile BYTE *) 0xF761) //Timer counter B1

#define TMRW (*(volatile BYTE *) 0xFF80) // Timer mode register W
#define TCRW (*(volatile BYTE *) 0xFF81) // Timer control register W
#define TIERW (*(volatile BYTE *) 0xFF82) // Timer interrupt enable register W
#define TSRW (*(volatile BYTE *) 0xFF83) // Timer status register W
#define TIOR0 (*(volatile BYTE *) 0xFF84) // Timer I/O control register 0
#define TIOR1 (*(volatile BYTE *) 0xFF85) // Timer I/O control register 1
#define TCNT (*(volatile WORD *) 0xFF86) // Timer counter
#define GRA (*(volatile WORD *) 0xFF88) // General register A
#define GRB (*(volatile WORD *) 0xFF8A) // General register B
#define GRC (*(volatile WORD *) 0xFF8C) // General register C
#define GRD (*(volatile WORD *) 0xFF8E) // General register D
#define FLMCR1 (*(volatile BYTE *) 0xFF90) // Flash memory control register 1
#define FLMCR2 (*(volatile BYTE *) 0xFF91) // Flash memory control register 2
#define FLPWCR (*(volatile BYTE *) 0xFF92) // Flash memory power control register
#define EBR1 (*(volatile BYTE *) 0xFF93) // Erase block register 1
#define FENR (*(volatile BYTE *) 0xFF9B) // Flash memory enable register
#define TCRV0 (*(volatile BYTE *) 0xFFA0) // Timer control register V0
#define TCSRV (*(volatile BYTE *) 0xFFA1) // Timer control/status register V
#define TCORA (*(volatile BYTE *) 0xFFA2) // Timer constant register A
#define TCORB (*(volatile BYTE *) 0xFFA3) // Timer constant register B
#define TCNTV (*(volatile BYTE *) 0xFFA4) // Timer counter V
#define TCRV1 (*(volatile BYTE *) 0xFFA5) // Timer control register V1
#define TMA (*(volatile BYTE *) 0xFFA6) // Timer mode register A
#define TCA (*(volatile BYTE *) 0xFFA7) // Timer counter A
#define SMR (*(volatile BYTE *) 0xFFA8) // Serial mode register
#define BRR (*(volatile BYTE *) 0xFFA9) // Bit rate register
#define SCR3 (*(volatile BYTE *) 0xFFAA) // Serial control register
#define TDR (*(volatile BYTE *) 0xFFAB) // Trasmit data register
#define SSR (*(volatile BYTE *) 0xFFAC) // Serial status register
#define RDR (*(volatile BYTE *) 0xFFAD) // Receive data register
#define ADDRA (*(volatile WORD *) 0xFFB0) // A/D data register A
#define ADDRB (*(volatile WORD *) 0xFFB2) // A/D data register B
#define ADDRC (*(volatile WORD *) 0xFFB4) // A/D data register C
#define ADDRD (*(volatile WORD *) 0xFFB6) // A/D data register D
#define ADCSR (*(volatile BYTE *) 0xFFB8) // A/D control status register
#define ADCR (*(volatile BYTE *) 0xFFB9) // A/D control register

#define PWDRL (*(volatile BYTE *) 0xFFBC) //PWM data register L
#define PWDRU (*(volatile BYTE *) 0xFFBD) //PWM data register U
#define PWCR (*(volatile BYTE *) 0xFFBE) //PWM control register

#define TCSRWD (*(volatile BYTE *) 0xFFC0) // Timer control/status register WD
#define TCWD (*(volatile BYTE *) 0xFFC1) // Timer counter WD
#define TMWD (*(volatile BYTE *) 0xFFC2) // Timer mode register WD
#define ICCR (*(volatile BYTE *) 0xFFC4) // I2C bus control register
#define ICSR_3664 (*(volatile BYTE *) 0xFFC5) // I2C bus status register
#define ICDR_SARX (*(volatile BYTE *) 0xFFC6) // I2C bus data register/Second slave address register
#define ICMR_SAR (*(volatile BYTE *) 0xFFC7) // I2C bus mode register/Slave address register
#define ABRKCR (*(volatile BYTE *) 0xFFC8) // Address break control register
#define ABRKSR (*(volatile BYTE *) 0xFFC9) // Address break statue register
#define BARH (*(volatile BYTE *) 0xFFCA) // Break address register H
#define BARL (*(volatile BYTE *) 0xFFCB) // Break address register L
#define BDRH (*(volatile BYTE *) 0xFFCC) // Break data register H
#define BDRL (*(volatile BYTE *) 0xFFCD) // Break data register L
#define PUCR1 (*(volatile BYTE *) 0xFFD0) // Port pull-up control register 1
#define PUCR5 (*(volatile BYTE *) 0xFFD1) // Port pull-up control register 5
#define PDR1 (*(volatile BYTE *) 0xFFD4) // Port data register 1
#define PDR2 (*(volatile BYTE *) 0xFFD5) // Port data register 2

#define PDR3 (*(volatile BYTE *) 0xFFD6) // Port data register 3

#define PDR5 (*(volatile BYTE *) 0xFFD8) // Port data register 5

#define PDR6 (*(volatile BYTE *) 0xFFD9) // Port data register 6

#define PDR7 (*(volatile BYTE *) 0xFFDA) // Port data register 7
#define PDR8 (*(volatile BYTE *) 0xFFDB) // Port data register 8
#define PDRB (*(volatile BYTE *) 0xFFDD) // Port data register B
#define PMR1 (*(volatile BYTE *) 0xFFE0) // Port mode register 1
#define PMR5 (*(volatile BYTE *) 0xFFE1) // Port mode register 5

#define PMR3 (*(volatile BYTE *) 0xFFE2) // Port mode register 3

#define PCR1 (*(volatile BYTE *) 0xFFE4) // Port control register 1
#define PCR2 (*(volatile BYTE *) 0xFFE5) // Port control register 2

#define PCR3 (*(volatile BYTE *) 0xFFE6) // Port control register 3

#define PCR5 (*(volatile BYTE *) 0xFFE8) // Port control register 5

#define PCR6 (*(volatile BYTE *) 0xFFE9) // Port control register 6

#define PCR7 (*(volatile BYTE *) 0xFFEA) // Port control register 7
#define PCR8 (*(volatile BYTE *) 0xFFEB) // Port control register 8
#define SYSCR1 (*(volatile BYTE *) 0xFFF0) // System control register 1
#define SYSCR2 (*(volatile BYTE *) 0xFFF1) // System control register 2
#define IEGR1 (*(volatile BYTE *) 0xFFF2) // Interrupt edge select register 1
#define IEGR2 (*(volatile BYTE *) 0xFFF3) // Interrupt edge select register 2
#define IENR1 (*(volatile BYTE *) 0xFFF4) // Interrupt enable register 1

#define IENR2 (*(volatile BYTE *) 0xFFF5) // Interrupt enable register 2

#define IRR1 (*(volatile BYTE *) 0xFFF6) // Interrupt flag register 1

#define IRR2 (*(volatile BYTE *) 0xFFF7) // Interrupt flag register 2

#define IWPR (*(volatile BYTE *) 0xFFF8) // Wake-up interrupt flag register
#define MSTCR1 (*(volatile BYTE *) 0xFFF9) // Module standby control regsiter 1

#define MSTCR2 (*(volatile BYTE *) 0xFFFA) // Module standby control regsiter 2

#define TSCR (*(volatile BYTE *) 0xFFFC) // Timer serial control register
#endif /* _H8_REG_DEFS_H_ */

// End of BAP28
#else // BAP40 and Arc32
//************************************
//Undefine any of the below interrupts
//you want to use in your program
//************************************
//
//#define USEINT_IRQ_0
//#define USEINT_IRQ_1
//#define USEINT_IRQ_2
//#define USEINT_IRQ_3
//#define USEINT_WKP
//#define USEINT_TIMERAV
//#define USEINT_TIMERW
//#define USEINT_TIMERV
//#define USEINT_SCI3
//#define USEINT_IIC
//#define USEINT_ADCONV
//#define USEINT_TIMERZ0
//#define USEINT_TIMERZ1
//#define USEINT_TIMERB1
//#define USEINT_SSC3_2

//**********************
//CCR macros and inlines
//**********************
#define and_ccr(mask) asm ("andc.b %0,ccr"::"g"(mask));
#define or_ccr(mask) asm ("orc.b %0,ccr"::"g"(mask));
#define xor_ccr(mask) asm ("xorc.b %0,ccr"::"g"(mask));

__inline__ unsigned char get_ccr(void) __attribute__ ((always_inline));
__inline__ unsigned char get_ccr(void)
{
      unsigned char ccr_val;
      asm("stc ccr,r0l":::"r0");
      asm("mov.b r0l, %0l":"=g"(ccr_val));
      return(ccr_val);
}

//**********************
//Simple type definition
//**********************
union BYTE {
	unsigned char Byte;
	struct {
		unsigned char Bit7:1;
		unsigned char Bit6:1;
		unsigned char Bit5:1;
		unsigned char Bit4:1;
		unsigned char Bit3:1;
		unsigned char Bit2:1;
		unsigned char Bit1:1;
		unsigned char Bit0:1;
	};
};

union WORD {
	unsigned int Word;
	struct {
		unsigned char Byte1;
		unsigned char Byte0;
	};
	struct {
		unsigned char Bit15:1;
		unsigned char Bit14:1;
		unsigned char Bit13:1;
		unsigned char Bit12:1;
		unsigned char Bit11:1;
		unsigned char Bit10:1;
		unsigned char Bit9:1;
		unsigned char Bit8:1;
		unsigned char Bit7:1;
		unsigned char Bit6:1;
		unsigned char Bit5:1;
		unsigned char Bit4:1;
		unsigned char Bit3:1;
		unsigned char Bit2:1;
		unsigned char Bit1:1;
		unsigned char Bit0:1;
	};
};

union LONG {
	unsigned long Long;
	struct {
		unsigned int Word1;
		unsigned int Word0;
	};
	struct {
		unsigned char Byte3;
		unsigned char Byte2;
		unsigned char Byte1;
		unsigned char Byte0;
	};
	struct {
		unsigned char Bit31:1;
		unsigned char Bit30:1;
		unsigned char Bit29:1;
		unsigned char Bit28:1;
		unsigned char Bit27:1;
		unsigned char Bit26:1;
		unsigned char Bit25:1;
		unsigned char Bit24:1;
		unsigned char Bit23:1;
		unsigned char Bit22:1;
		unsigned char Bit21:1;
		unsigned char Bit20:1;
		unsigned char Bit19:1;
		unsigned char Bit18:1;
		unsigned char Bit17:1;
		unsigned char Bit16:1;
		unsigned char Bit15:1;
		unsigned char Bit14:1;
		unsigned char Bit13:1;
		unsigned char Bit12:1;
		unsigned char Bit11:1;
		unsigned char Bit10:1;
		unsigned char Bit9:1;
		unsigned char Bit8:1;
		unsigned char Bit7:1;
		unsigned char Bit6:1;
		unsigned char Bit5:1;
		unsigned char Bit4:1;
		unsigned char Bit3:1;
		unsigned char Bit2:1;
		unsigned char Bit1:1;
		unsigned char Bit0:1;
	};
};

#ifndef _H8_REG_DEFS_H_
//*****************************
//Hardware Register Definitions
//*****************************
#define TCR_0 (*(volatile BYTE *) 0xF700) //Timer control register 0
#define TIORA_0 (*(volatile BYTE *) 0xF701) //Timer I/O control register A 0
#define TIORC_0 (*(volatile BYTE *) 0xF702) //Timer I/O control register C 0
#define TSR_0 (*(volatile BYTE *) 0xF703) //Tiemr status register 0
#define TIER_0 (*(volatile BYTE *) 0xF704) //Timer interrupt enable register 0
#define POCR_0 (*(volatile BYTE *) 0xF705) //PWM mode output level control register 0
#define TCNT_0 (*(volatile WORD *) 0xF706) //Timer counter 0
#define GRA_0 (*(volatile WORD *) 0xF708) //General register A 0
#define GRB_0 (*(volatile WORD *) 0xF70A) //General register B 0
#define GRC_0 (*(volatile WORD *) 0xF70C) //General register C 0
#define GRD_0 (*(volatile WORD *) 0xF70E) //General register D 0
#define TCR_1 (*(volatile BYTE *) 0xF710) //Timer control register 1
#define TIORA_1 (*(volatile BYTE *) 0xF711) //Timer I/O control register A 1
#define TIORC_1 (*(volatile BYTE *) 0xF712) //Timer I/O control register C 1
#define TSR_1 (*(volatile BYTE *) 0xF713) //Tiemr status register 1
#define TIER_1 (*(volatile BYTE *) 0xF714) //Timer interrupt enable register 1
#define POCR_1 (*(volatile BYTE *) 0xF715) //PWM mode output level control register 1
#define TCNT_1 (*(volatile WORD *) 0xF716) //Timer counter 1
#define GRA_1 (*(volatile WORD *) 0xF718) //General register A 1
#define GRB_1 (*(volatile WORD *) 0xF71A) //General register B 1
#define GRC_1 (*(volatile WORD *) 0xF71C) //General register C 1
#define GRD_1 (*(volatile WORD *) 0xF71E) //General register D 1
#define TSTR (*(volatile BYTE *) 0xF720) //Timer start register
#define TMDR (*(volatile BYTE *) 0xF721) //Timer mode register
#define TPMR (*(volatile BYTE *) 0xF722) //Timer PWM mode register
#define TFCR (*(volatile BYTE *) 0xF723) //Timer Z, for common use
#define TOER (*(volatile BYTE *) 0xF724) //Timer output master enable register
#define TOCR (*(volatile BYTE *) 0xF725) //Timer output control register

#define RSECDR (*(volatile BYTE *) 0xF728) //Second data register
#define RMINDR (*(volatile BYTE *) 0xF729) //Minute data register
#define RHRDR (*(volatile BYTE *) 0xF72A) //Hour data register
#define RWKDR (*(volatile BYTE *) 0xF72B) //Day of week data register
#define RTCCR1 (*(volatile BYTE *) 0xF72C) //RTC control register 1
#define RTCCR2 (*(volatile BYTE *) 0xF72D) //RTC control register 2
#define RTCCSR (*(volatile BYTE *) 0xF72F) //Clock source select register

#define LVDCR (*(volatile BYTE *) 0xF730) //Low voltage detection control register
#define LVDSR (*(volatile BYTE *) 0xF731) // Low voltage detection status register

#define SMR_2 (*(volatile BYTE *) 0xF740) //Serial mode reigster 2
#define BRR_2 (*(volatile BYTE *) 0xF741) //Bit rate register 2
#define SCR3_2 (*(volatile BYTE *) 0xF742) //Serial control register 3 2
#define TDR_2 (*(volatile BYTE *) 0xF743) //Transmit data register 2
#define SSR_2 (*(volatile BYTE *) 0xF744) //Serial status register 2
#define RDR_2 (*(volatile BYTE *) 0xF745) //Receive data register 2

#define ICCR1 (*(volatile BYTE *) 0xF748) //I2C bus control register 1
#define ICCR2 (*(volatile BYTE *) 0xF749) //I2C bus control register 2
#define ICMR (*(volatile BYTE *) 0xF74A) //I2C bus mode register
#define ICIER (*(volatile BYTE *) 0xF74B) //I2C bus interrupt enable register
#define ICSR (*(volatile BYTE *) 0xF74C) //I2C status register
#define SAR (*(volatile BYTE *) 0xF74D) //Slave address register
#define ICDRT (*(volatile BYTE *) 0xF74E) //I2C bus transmit data register
#define ICDRR (*(volatile BYTE *) 0xF74F) //I2C bus receiver data register

#define TMB1 (*(volatile BYTE *) 0xF760) //Timer mode register B1
#define TCB1 (*(volatile BYTE *) 0xF761) //Timer counter B1

#define TMRW (*(volatile BYTE *) 0xFF80) // Timer mode register W
#define TCRW (*(volatile BYTE *) 0xFF81) // Timer control register W
#define TIERW (*(volatile BYTE *) 0xFF82) // Timer interrupt enable register W
#define TSRW (*(volatile BYTE *) 0xFF83) // Timer status register W
#define TIOR0 (*(volatile BYTE *) 0xFF84) // Timer I/O control register 0
#define TIOR1 (*(volatile BYTE *) 0xFF85) // Timer I/O control register 1
#define TCNT (*(volatile WORD *) 0xFF86) // Timer counter
#define GRA (*(volatile WORD *) 0xFF88) // General register A
#define GRB (*(volatile WORD *) 0xFF8A) // General register B
#define GRC (*(volatile WORD *) 0xFF8C) // General register C
#define GRD (*(volatile WORD *) 0xFF8E) // General register D
#define FLMCR1 (*(volatile BYTE *) 0xFF90) // Flash memory control register 1
#define FLMCR2 (*(volatile BYTE *) 0xFF91) // Flash memory control register 2
#define FLPWCR (*(volatile BYTE *) 0xFF92) // Flash memory power control register
#define EBR1 (*(volatile BYTE *) 0xFF93) // Erase block register 1
#define FENR (*(volatile BYTE *) 0xFF9B) // Flash memory enable register
#define TCRV0 (*(volatile BYTE *) 0xFFA0) // Timer control register V0
#define TCSRV (*(volatile BYTE *) 0xFFA1) // Timer control/status register V
#define TCORA (*(volatile BYTE *) 0xFFA2) // Timer constant register A
#define TCORB (*(volatile BYTE *) 0xFFA3) // Timer constant register B
#define TCNTV (*(volatile BYTE *) 0xFFA4) // Timer counter V
#define TCRV1 (*(volatile BYTE *) 0xFFA5) // Timer control register V1
#define TMA (*(volatile BYTE *) 0xFFA6) // Timer mode register A
#define TCA (*(volatile BYTE *) 0xFFA7) // Timer counter A
#define SMR (*(volatile BYTE *) 0xFFA8) // Serial mode register
#define BRR (*(volatile BYTE *) 0xFFA9) // Bit rate register
#define SCR3 (*(volatile BYTE *) 0xFFAA) // Serial control register
#define TDR (*(volatile BYTE *) 0xFFAB) // Trasmit data register
#define SSR (*(volatile BYTE *) 0xFFAC) // Serial status register
#define RDR (*(volatile BYTE *) 0xFFAD) // Receive data register
#define ADDRA (*(volatile WORD *) 0xFFB0) // A/D data register A
#define ADDRB (*(volatile WORD *) 0xFFB2) // A/D data register B
#define ADDRC (*(volatile WORD *) 0xFFB4) // A/D data register C
#define ADDRD (*(volatile WORD *) 0xFFB6) // A/D data register D
#define ADCSR (*(volatile BYTE *) 0xFFB8) // A/D control status register
#define ADCR (*(volatile BYTE *) 0xFFB9) // A/D control register

#define PWDRL (*(volatile BYTE *) 0xFFBC) //PWM data register L
#define PWDRU (*(volatile BYTE *) 0xFFBD) //PWM data register U
#define PWCR (*(volatile BYTE *) 0xFFBE) //PWM control register

#define TCSRWD (*(volatile BYTE *) 0xFFC0) // Timer control/status register WD
#define TCWD (*(volatile BYTE *) 0xFFC1) // Timer counter WD
#define TMWD (*(volatile BYTE *) 0xFFC2) // Timer mode register WD
#define ICCR (*(volatile BYTE *) 0xFFC4) // I2C bus control register
#define ICSR_3664 (*(volatile BYTE *) 0xFFC5) // I2C bus status register
#define ICDR_SARX (*(volatile BYTE *) 0xFFC6) // I2C bus data register/Second slave address register
#define ICMR_SAR (*(volatile BYTE *) 0xFFC7) // I2C bus mode register/Slave address register
#define ABRKCR (*(volatile BYTE *) 0xFFC8) // Address break control register
#define ABRKSR (*(volatile BYTE *) 0xFFC9) // Address break statue register
#define BARH (*(volatile BYTE *) 0xFFCA) // Break address register H
#define BARL (*(volatile BYTE *) 0xFFCB) // Break address register L
#define BDRH (*(volatile BYTE *) 0xFFCC) // Break data register H
#define BDRL (*(volatile BYTE *) 0xFFCD) // Break data register L
#define PUCR1 (*(volatile BYTE *) 0xFFD0) // Port pull-up control register 1
#define PUCR5 (*(volatile BYTE *) 0xFFD1) // Port pull-up control register 5
#define PDR1 (*(volatile BYTE *) 0xFFD4) // Port data register 1
#define PDR2 (*(volatile BYTE *) 0xFFD5) // Port data register 2

#define PDR3 (*(volatile BYTE *) 0xFFD6) // Port data register 3

#define PDR5 (*(volatile BYTE *) 0xFFD8) // Port data register 5

#define PDR6 (*(volatile BYTE *) 0xFFD9) // Port data register 6

#define PDR7 (*(volatile BYTE *) 0xFFDA) // Port data register 7
#define PDR8 (*(volatile BYTE *) 0xFFDB) // Port data register 8
#define PDRB (*(volatile BYTE *) 0xFFDD) // Port data register B
#define PMR1 (*(volatile BYTE *) 0xFFE0) // Port mode register 1
#define PMR5 (*(volatile BYTE *) 0xFFE1) // Port mode register 5

#define PMR3 (*(volatile BYTE *) 0xFFE2) // Port mode register 3

#define PCR1 (*(volatile BYTE *) 0xFFE4) // Port control register 1
#define PCR2 (*(volatile BYTE *) 0xFFE5) // Port control register 2

#define PCR3 (*(volatile BYTE *) 0xFFE6) // Port control register 3

#define PCR5 (*(volatile BYTE *) 0xFFE8) // Port control register 5

#define PCR6 (*(volatile BYTE *) 0xFFE9) // Port control register 6

#define PCR7 (*(volatile BYTE *) 0xFFEA) // Port control register 7
#define PCR8 (*(volatile BYTE *) 0xFFEB) // Port control register 8
#define SYSCR1 (*(volatile BYTE *) 0xFFF0) // System control register 1
#define SYSCR2 (*(volatile BYTE *) 0xFFF1) // System control register 2
#define IEGR1 (*(volatile BYTE *) 0xFFF2) // Interrupt edge select register 1
#define IEGR2 (*(volatile BYTE *) 0xFFF3) // Interrupt edge select register 2
#define IENR1 (*(volatile BYTE *) 0xFFF4) // Interrupt enable register 1

#define IENR2 (*(volatile BYTE *) 0xFFF5) // Interrupt enable register 2

#define IRR1 (*(volatile BYTE *) 0xFFF6) // Interrupt flag register 1

#define IRR2 (*(volatile BYTE *) 0xFFF7) // Interrupt flag register 2

#define IWPR (*(volatile BYTE *) 0xFFF8) // Wake-up interrupt flag register
#define MSTCR1 (*(volatile BYTE *) 0xFFF9) // Module standby control regsiter 1

#define MSTCR2 (*(volatile BYTE *) 0xFFFA) // Module standby control regsiter 2

#define TSCR (*(volatile BYTE *) 0xFFFC) // Timer serial control register
#endif	// _H8_REG_DEFS_H_
#endif // _REGDEFS_H_
