;*********************************************************************
; 
;  System initialisation routine - entry point for the application.
;  The stack pointer is initialised, then the hardware initialisation
;  routine called.  The static data areas are then initialised, before
;  the main function is executed.  A simple exit funtion is also
;  supplied
;
;*********************************************************************

	.h8300h
	.section .text
	.global _start
	.global _exit

	.extern _hw_initialise
	.extern _main

	.extern _data
	.extern _mdata
	.extern _edata
	.extern _bss
	.extern _ebss
	.extern _stack

_start:
	; initialise the SP for non-ored code
	mov.w   #_stack,r7
	; call the hardware initialiser
	jsr     @_hw_initialise
	
	; get the boundaries for the .data section initialisation
	mov.w   #_data,r0
	mov.w   #_edata,r1
	mov.w   #_mdata,r2
	cmp.w   r0,r1
	beq     start_1
start_l:
	mov.b   @er2,r3l  ;get from src
	mov.b   r3l,@er0  ;place in dest
	adds.w   #1,er2    ;inc src
	adds.w   #1,er0    ;inc dest
	cmp.w   r0,r1   ;dest == edata?
	bne     start_l

start_1:
	; zero out bss
	mov.w   #_bss,r0
	mov.w   #_ebss,r1
	cmp.w   r0,r1         
	beq     start_3
	xor.b   r2l,r2l
start_2:
	mov.b   r2l,@er0
	adds.w   #1,er0
	cmp.w   r0,r1
	bne     start_2

start_3:
	jsr		@___main
	; call the mainline     
	jsr     @_main

	; jump to exit
	jmp     @_exit

_exit:  
	nop
	bra _exit

