
#include "globals.h"
#include "..\baplib\hsio.h"
#include "..\baplib\servo.h"

#ifdef BASICATOMPRO28
#define DBG_PIN1	4
#define DBG_PIN2	5
#define DBG_PIN3	6
#define DBG_BAUD	I9600
#else
#define DBG_PIN1	17
#define DBG_PIN2	18
#define DBG_PIN3	19
#define DBG_BAUD	I38400
#endif

#ifdef BASICATOMPROARC32
#define SND_PIN 20
#else
#define SND_PIN 9
#endif

unsigned char abMsg[]= "Message\n\r";
extern void TestHServo(void);



int main(void)
{

	bap_initialize();

#ifndef BASICATOMPRO28
	enablehserial(1);
	sethserial (1, 38400, 0, 0, 0);
#endif	
	DBGPrintf("Baplib Servo Test program\n\r");

    MSound(SND_PIN, 3, 60, 2000, 80, 2250, 100, 2500);
	TestHServo();

    MSound(SND_PIN, 3, 60, 2000, 80, 2250, 100, 2500);

	for (;;) {
		pause(150);
	}
	    
   return 0;
}

#ifdef DEBUG_CAPTURE_HSDATA
extern 	volatile bool	g_fCaptureNextHSData;
extern 	u16		g_awCaptureHSData[];	//try to capture some data
#endif

void TestHServo(void)
{
//#define SERVOMASK 0XFFFFFDFFL
//#define SERVOMASK 0XFFFFFDF0L	// for debug mode
#define SERVOMASK 0x00000000FFF0L	// on just pins 5-15 for this pass...
	int i;
	u32 u;
	u16 w;
	
	DBGPrintf("Before HServoInit\n\r");
	// Next lets simply do a few HSERVOS and see what we get
	toggle(DBG_PIN1);

	for (w=0; w < 10; w++) {
		HServoGroupMoveStart();
		u = SERVOMASK;
		for (i=0; i<32; i++) {
			if (u&1)
				HServo(i, 0);
			u >>= 1;
		}
		HServoGroupMoveCommit(50);
		HServoWait(SERVOMASK);
		pause (50);
		DBGPrintf("Do Free Pass %d\n\r", w);
	}	

	HServoGroupMoveStart();
	u = SERVOMASK;
	w = 500;
	for (i=0; i<32; i++) {
		if (u&1)
			HServo(i, w);
		w += 100;
		if (i > 2200)
			i = 500;
		u >>= 1;
	}
	HServoGroupMoveCommit(0);
	HServoWait(SERVOMASK);

#ifdef DEBUG_CAPTURE_HSDATA
	for (i=0; i < 5; i++) {
		g_fCaptureNextHSData = 1;
		while (g_fCaptureNextHSData) ;
		
		DBGPrintf("%d 0:%u %x %x - %x %x %x %x\n\r", g_awCaptureHSData[7], 
				g_awCaptureHSData[0], g_awCaptureHSData[1],  g_awCaptureHSData[2], 
				g_awCaptureHSData[3], g_awCaptureHSData[4], g_awCaptureHSData[5], g_awCaptureHSData[6]);
		DBGPrintf("1:%u %x %x - %x %x %x %x\n\r", 
				g_awCaptureHSData[8], g_awCaptureHSData[9],  g_awCaptureHSData[10], 
				g_awCaptureHSData[11], g_awCaptureHSData[12], g_awCaptureHSData[13], g_awCaptureHSData[14]);
	}
#endif
	DBGPrintf("Finished starting servo set\n\r");
	pause (100);
		
	for (w=0; w < 10; w++) {
		HServoGroupMoveStart();
		u = SERVOMASK;
		for (i=0; i<32; i++) {
			if (u&1)
				HServo(i, 0);
			u >>= 1;
		}
		HServoGroupMoveCommit(50);
		HServoWait(SERVOMASK);
		pause (50);
		DBGPrintf("Do Free Pass %d\n\r", w);
	}	
	

	HServoGroupMoveStart();
#ifdef BASICATOMPROARC32	
	HServo(8, 500);					
	HServo(9,1500);
	HServo(1, 1800);
	HServo(11, 800);
	HServo(24, 1650);
	HServo(19, 1400);
	HServo(6, 2500);
#else
	HServo(1, 1800);
	HServo(2, 800);
	HServo(4, 1800);
	HServo(5, 2000);
	HServo(8, 500);					
	HServo(10, 950);					
	
	HServo(14, 2500);
	HServo(15, 1900);
#endif
	HServoGroupMoveCommit(0);		
	DBGPrintf("After HServo\n\r");
	WaitForDBGTransmitComplete();

//	toggle(DBG_PIN1);
	pause (100);

	HServoGroupMoveStart();
	HServo(8, 2500);					
	HServoGroupMoveCommit(1000);		

	HServoWait(1<<8);
	toggle(DBG_PIN1);

//	pause (600);

	HServoGroupMoveStart();
	HServo(8, 500);					
	HServoGroupMoveCommit(500);		
	HServoWait(1<<8);
//	toggle(DBG_PIN1);

	HServoGroupMoveStart();
	HServo(8, 1500);					
	HServoGroupMoveCommit(500);		
	HServoWait(1<<8);
//	toggle(DBG_PIN1);
}	
